import { EventModel } from 'react-event-base/Core';
import { createEventTypes } from 'react-event-base/EventUtils';

class Mode extends EventModel {
  initialize() {
    console.log("----Initialize mode [".concat(this.type, "]"));
  }

  destroy() {}

}

var Events = createEventTypes(['Changed']);

class AbstractModeController extends EventModel {
  constructor(data) {
    super(data);
    this.modes = this.modes || {};
  }

  initializeModes(modes) {
    this.modes = modes;
  }

  destroyMode() {
    var {
      mode
    } = this;

    if (mode) {
      mode.destroy();
      delete this.mode;
    }
  }

  changeMode(key) {
    this.destroyMode();
    var ModeConstructor = this.modes[key];

    if (ModeConstructor) {
      this.key = key;
      var mode = this.mode = new ModeConstructor(this.modeArgs);
      mode.initialize();
      this.trigger(Events.Changed);
    } else {
      console.error("[ModeController] Invalid key of mode: ".concat(key));
    }
  }

}

export { Mode as AbstractMode, AbstractModeController, Events as ModeControllerEvents };
